/*
Shared header file for RDMA sendfile kernel module and user space library

Copyright (C) 2007 - Dennis Dalessandro  -  Ohio Supercomputer Center
                                         (dennis@osc.edu)

Distributed under the GNU Public License Version 2 (SEE LICENSE)
*/

//~ #define MAX_PAGE  ((int) (PAGE_SIZE / sizeof(struct ib_phys_buf)))
#define MAX_PAGE 256
#define MAX_OUTSTANDING 25   /*number of rdma writes that can be
			      going on at once*/

#define NO_FREE -1


//~ #define SEND_BOGUS  /*define when we want user library to send garbage data*/
//~ #define ZERO_WORK
//~ #define NO_REG
//~ #define NO_DEREG
//~ #define SKIP_LOOP

typedef enum{
	INIT = 1,
	FINI = 1 << 1,
	SEND_DATA = 1 << 2,
}op_mask_t;

typedef struct{
	int			pd_hndl;
	int			fd;
	int			ib_fd;
	loff_t			offset;
	int			count;
#ifdef RSF_KERNEL  /*not really necessary requires #define in rdma_sendfile.h*/
	uint32_t __user		*lkey;
	uint64_t __user		*addr;
	unsigned long __user	*actual_len;
#else
	uint32_t 		*lkey;
	uint64_t 		*addr;
	unsigned long 		*actual_len;
#endif
	int 			current_queue_num;
	int 			free_queue_num;
	op_mask_t		mask;
}user_info_t;
